﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;
namespace RepositionIssue
{
    public partial class Form1 : Form
    {
        DockableGroupPane tabGroup = null;
        DockAreaPane dockArea = null;
        public Form1()
        {
            InitializeComponent();
            List<Control> ctlList = new List<Control>();
            for (int i = 0; i < 4; i++)
            {
                UserControl1 u = new UserControl1();
                Control c = (Control)u;
                c.Name = "Control" + i.ToString();
                c.Text = "Control" + i.ToString();
                ctlList.Add(c);
            }
            AddDockControls(ctlList);


            //COMMENT THIS LINE TO SEE THE CONTROL ADDED
            RepositionControl("Control0", 1);

        }
        public void RepositionControl(string ctrlName, int position)
        {
            if (tabGroup != null
                && tabGroup.Panes.Count > 0
                && position <= tabGroup.Panes.Count)
            {
                //DockableControlPane selectedPane = null;
                foreach (DockablePaneBase pane in tabGroup.Panes)
                {
                    DockableControlPane p = pane as DockableControlPane;
                    if (p != null &&
                        p.Text == ctrlName)
                    {

                        p.RepositionToPane(this.ultraDockManager1.ControlPanes[position], PanePosition.Previous);

                    }
                }
                this.ultraDockManager1.ControlPanes[position].Activate();
            }
        }
        public void AddControl(Control control)
        {
            DockableControlPane pane = new DockableControlPane();
            pane.Control = control;
            pane.TextTab = control.Text;//grid.GridTabName;
            pane.Text = control.Name;
            pane.Maximized = true;
            tabGroup.Panes.Add(pane);
        }

        private void AddDockControls(List<Control> ctrlList)
        {

            DockableControlPane pane;
            List<DockablePaneBase> paneList = new List<DockablePaneBase>();

            foreach (Control ctrl in ctrlList)
            {
                pane = new DockableControlPane();
                pane.Control = ctrl;
                pane.TextTab = ctrl.Text;//grid.GridTabName;
                pane.Text = ctrl.Name;
                pane.Maximized = true;


                paneList.Add(pane);
            }


            SetPanes(paneList);


        }

        private void SetPanes(List<DockablePaneBase> paneList)
        {
            if (tabGroup == null)
                tabGroup = new DockableGroupPane();

            tabGroup.Panes.AddRange(paneList.ToArray());
            tabGroup.ChildPaneStyle = ChildPaneStyle.TabGroup;
            tabGroup.Show();
            if (dockArea == null)
            {
                dockArea = new DockAreaPane(DockedLocation.DockedLeft);
                dockArea.Key = "t";
            }
            dockArea.Panes.Add(tabGroup);
            dockArea.ChildPaneStyle = ChildPaneStyle.TabGroup;
            dockArea.Maximized = true;
            ultraDockManager1.DockAreas.Add(dockArea);
            ultraDockManager1.LayoutStyle = DockAreaLayoutStyle.FillContainer;
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            UserControl1 u = new UserControl1();
            Control c = (Control)u;
            c.Name = "Control-New";
            c.Text = "Control-New";

            AddControl(c);
        }
    }
}
